# $Id: boa.spec,v 1.1 2003/10/22 14:39:40 dude Exp $

%define rcver rc17
%define webroot /var/www/boa

Summary: The boa web server
Name: boa
Version: 0.94.14
Release: %{?rcver:0.%{rcver}.}1.fr
Source0: http://www.boa.org/%{name}-%{version}%{?rcver}.tar.bz2
Source1: boa.init
Source2: boa.sysconfig
Source10: index.html
Source11: boa_logo_pasi2.png
Source12: button-freshrpms.png
Patch: boa-0.94.14rc17-config.patch
URL: http://www.boa.org/
License: GPL
Group: System Environment/Daemons
BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildRequires: tetex, texinfo
%{!?_without_gunzip:Requires: gzip}
%{!?_without_gunzip:BuildRequires: gzip}
Requires: /etc/mime.types
Provides: webserver

%description
Boa is a single-tasking HTTP server. That means that unlike traditional web
servers, it does not fork for each incoming connection, nor does it fork many
copies of itself to handle multiple connections. It internally multiplexes
all of the ongoing HTTP connections, and forks only for CGI programs (which
must be separate processes), automatic directory generation, and automatic
file gunzipping.
The primary design goals of Boa are speed and security. Security, in the sense
of "can't be subverted by a malicious user," not "fine grained access control
and encrypted communications". Boa is not intended as a feature-packed server.

Available rpmbuild rebuild options :
--with : debug access poll
--without : gunzip sendfile

%prep
%setup -q -n %{name}-%{version}%{?rcver}
%patch -p1 -b .config

%build
%configure \
    %{!?_with_debug:      --disable-debug} \
    %{?_with_access:      --enable-access-control} \
    %{?_with_poll:        --with-poll} \
    %{?_without_gunzip:   --disable-gunzip} \
    %{?_without_sendfile: --disable-sendfile}
make
make -C docs

%install
rm -rf %{buildroot}
# Manual install is still mandatory
install -m 755 -D src/boa %{buildroot}%{_sbindir}/boa
install -m 755 -D src/boa_indexer %{buildroot}%{_libdir}/boa/boa_indexer
install -m 644 -D docs/boa.8 %{buildroot}%{_mandir}/man8/boa.8
install -m 644 -D examples/boa.conf %{buildroot}%{_sysconfdir}/boa/boa.conf
install -m 644 -D contrib/redhat/boa.logrotate %{buildroot}%{_sysconfdir}/logrotate.d/boa
install -m 755 -D %{SOURCE1} %{buildroot}%{_initrddir}/boa
install -m 755 -D %{SOURCE2} %{buildroot}%{_sysconfdir}/sysconfig/boa

mkdir -p %{buildroot}/%{webroot}/html
mkdir -p %{buildroot}/%{_localstatedir}/log/boa

# Install the default index.html file
install -m 644 %{SOURCE10} %{SOURCE11} %{SOURCE12} %{buildroot}%{webroot}/html/

%clean
rm -rf %{buildroot}

%pre
/usr/sbin/groupadd -r www 2>/dev/null || :
/usr/sbin/useradd -s /bin/false -c "Web server user" \
        -d %{webroot} -M -r -g www boa 2>/dev/null || :

%post
if [ $1 = 1 ]; then
    /sbin/chkconfig --add boa
fi

%preun
if [ $1 = 0 ]; then
    /sbin/service boa stop >/dev/null 2>&1 || :
    /sbin/chkconfig --del boa
fi

%postun
if [ $1 -ge 1 ]; then
    /sbin/service boa condrestart >/dev/null 2>&1 || :
fi

%files
%defattr(-, root, root, 0755)
%doc docs/*.{html,png,txt} COPYING CREDITS README examples/
%dir %{_sysconfdir}/boa
%config(noreplace) %{_sysconfdir}/boa/boa.conf
%config(noreplace) %{_sysconfdir}/logrotate.d/boa
%config(noreplace) %{_sysconfdir}/sysconfig/boa
%{_initrddir}/boa
%dir %{_libdir}/boa
%{_libdir}/boa/boa_indexer
%{_sbindir}/boa
%{webroot}
%dir %{_localstatedir}/log/boa
%{_mandir}/man8/*

%changelog
* Wed Oct 22 2003 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Initial package.

